1 Introduction

In the past decades, wireless sensor networks have brought tremendous changes to human society and proposed many technique challenges. Among them, the coverage topic including area coverage [10] and barrier coverage [8] is one of the hot spots that attract lots of research interest. In area coverage, the task is to schedule the new positions of the sensors, such that each point in the given target region is covered by at least one sensor. Differently, in barrier cover the task is to monitor only the boundary of a given region, and the aim is to guarantee that intruders can be found when they are crossing the barrier. Comparing to area coverage, barrier coverage has an advantage of using significantly less sensors and hence is scalable for large scale wireless sensor networks (WSN). Furthermore, some applications only require a set of Points Of Interest (POIs) along the boundary to be monitored. In the context, a problem arises how to guarantee every POI on the barrier to be covered. The current-state-of-art method is to firstly cover POIs using the stationary sensors, and secondly use mobile sensors to cover every not-yet covered POI along the boundary. For the second phase, we traditionally have the following assumptions for the modeling: (1) Sensors are acquired with mobile ability; (2) The initial positions of the sensors are distributed on the plane, and the POIs are distributed along a line segment (Although the shape of the boundary can be various, most researches nonetheless focus on line boundary since curves of other shapes can be considered as a variable); (3) The aim of the sensor network is to prolong the lifetime. This arises the min-max 2D Line Boundary Target Coverage problem in (min-max 2D-LBTC) as follows:

Definition 1

Let \(\varPsi \) and \(\varGamma \) be respectively a set of POIs distributed in a line segment \([0,\,M]\) and a set of mobile sensors distributed on the plane, where \(j\in \varPsi \) has a position \((p_{j},\,0)\) and \(i\in \varGamma \) has a position \((x_{i},\,y_{i})\) and a positive sensing radius \(r_{i}\). The min-max 2D-LBTC problem aims to compute a new position \((x'_{i},\,0)\) for each sensor \(i\in \varGamma \), such that each POI \(j\in \varPsi \) is covered by at least one sensor, i.e. for each POI \(j\in \varPsi \) there exists a sensor \(i\in \varGamma \) with position \((x'_{i},\,0)\) that \(x'_{i}-r_{i}\le p_{i}\le x'_{i}+r_{i}\), and the maximum movement of the sensors from their original positions to the new positions is minimized, i.e. \(\max _{i\in \varGamma }\left\{ \left. \sqrt{(x_{i}-x_{i}')^{2}+y_{i}{}^{2}}\right| i\in \varGamma \right\} \) is minimized.

When no confusion arises, we shall use LBTC short for the min-max 2D-LBTC problem for the sake of briefness. In particular, we use one dimensional min-max Line Boundary Target Coverage problem (1D-LBTC) to denote the special case of LBTC when the initial positions of all the sensors are also distributed on the line boundary \([0,\,M]\). Moreover, the decision version of LBTC (decision LBTC for short) is, for a given movement bound D, to determine whether there exists a feasible coverage with each sensor’s movement bounded by D. Besides, when the aim is to cover the line boundary itself instead of the POIs thereon, we respectively have the min-max Line Boundary Coverage (LBC) problem and one-dimensional-LBC (1D-LBC) problem, which have already been well studied and a number of algorithms have been developed.

1.1 Related Works

To the best of our knowledge, Kumar et al. [8] were the first to consider the barrier coverage problem using sensors against a closed curve (i.e., a moat), via transforming the coverage problem to the path problem of determining whether there exists a path between two specified nodes, although the research of barrier coverage started from early 90s in the last century due to Gage [7]. The algorithm from Kumar et al. is scalable and can also be extended to solve the k-coverage problem by transforming to the k-disjoint path problem, but can only be used to determine whether a coverage exists using the deployed stationary sensors. A problem for stationary sensors is that, after deployment there might exist no coverage over all targets. For the case, a state-of-art solution is to employ mobile sensors to fill the gaps between the stationary sensors. In the scenario, the WSN applications would require to maximize the minimum lifetime of the mobile sensors or to minimize the total energy consumption. For the former, the aim is to schedule new positions for the mobile sensors such that the barrier is completely covered, and that the maximum movement of the sensors is minimized as to prolong the lifetime of the WSN. When the sensors are on the line of the barrier, the 1D-LBC problem is shown optimally solvable in \(O(n^{2})\) time for uniform radius in Paper [4]. The same paper has also proposed an algorithm with O(n) time for uniform radii and \(\sum _{i}r_{i}\le L\), and with \(x_{1}\le \cdots \le x_{n}\) for the sensor \(\varGamma =\{s_{1},\,\cdots ,\,s_{n}\}\), where L is the length of the barrier, n is the number of the sensors. Later, Chen et al. have improved the time complexity to \(O(n\log n)\) for uniform sensor radii and proposed an \(O(n^{2}\log n)\) time algorithm for non-uniform radii in paper [2]. Besides straight line barrier, circle/simple polygon barriers has been studied and two algorithms have been given developed by Bhattacharya et al. in [1], which have an \(O(n^{3.5}\log n)\) time relative to cycle barriers and an \(O(mn^{3.5}\log n)\) time relative to polygon barriers, in which m is the number of the edges on the polygon. The later time complexity was then decreased to \(O(n^{2.5}\log n)\) in [12]. For the more generalized case in which the sensors are distributed on the plane, the LBC problem is known to be strongly \(\mathcal{NP}\)-hard for sensors with general integral sensing radius [6], while LBC using uniform radius sensors is shown solvable in \(O(n^{3}\log n)\) time [9].

Other than the Min-Max case, there are also applications require min-sum coverage that is to minimize the total energy consumption, which is to minimize the total movement of the mobile sensors. For this objective, both Min-Sum LBC and LBTC, which aim to minimize the sum of the movements of all the sensors, were studied in literature. Min-Sum LBC was shown \(\mathcal{NP}\)-complete for arbitrary radius while solvable in time \(O(n^{2})\) for uniform radii by Czyzowicz et al. [5]. The Min-Num relocation problem of minimizing the number of sensors moved, is also proven \(\mathcal{NP}\)-complete for arbitrary radii and polynomial solvable for uniform radii by Mehrandish et al. [11]. A PTAS has been developed for the Min-Sum relocation problem against circle/simple polygon barriers by Bhattacharya et al. [1], which was later improved to an \(O(n^{4})\) time exact algorithm by Tan and Wu [12]. For covering targets with Min-Sum movement, the most recent result is a factor-\(\sqrt{2}\) approximation algorithm for covering targets along a barrier using uniform-radius sensors, aiming to minimize the sum of the movement [3]. However, it remains open whether the min-sum LBC problem is \(\mathcal{NP}\)-hard.

1.2 Our Results

In this paper, we first show that 1D-LBTC is \(\mathcal{NP}\)-hard when the sensors are with non-uniform integral radii by proposing a reduction from the 3-partition problem that is known strongly \(\mathcal{NP}\)-complete. This hardness result is surprising, because 1D-LBC, the continuous version of 1D-LBTC, is shown solvable in polynomial time \(O(n^{2}\log n)\).

Then, we propose a sufficient and necessary condition to determine whether there exists a feasible cover for the barrier under the relocation distance bound D. Based on the condition, we propose a simple greedy approach that outputs “infeasible” if \(D<D^{*}\), and otherwise computes a feasible solution under the movement bound D, such that new positions for the sensors wrt which each target is monitored by at least a sensor. We show that the decision algorithm is with a runtime \(O(n\log n)\). By employing the binary search technique, we propose an algorithm using the decision algorithm as a routine which takes \(O(n\log n\log (d_{max}+L))\) time to actually find a minimum integral movement bound \(D=D^{*}\), where \(d_{max}\) is the maximum distance between the sensors and the POIs, and L is the length of the line segment.

For instances with large \(d_{max}\) and L, we propose another algorithm that employs the binary search method against O(mn) possible values of \(D^{*}\) instead of the continuous value range. This improves the runtime of the algorithm to \(O(mn(\log m+\log n))\), which is the time needed to sort the O(mn) values. The later algorithm remains correct even when D is any real number. In contrast, the former algorithm only works for integral \(D^{*}\).

1.3 Organization

The following paragraphs will be organized as below: Sect. 2 gives the \(\mathcal{NP}\)-completeness proof; Sect. 3 presents the algorithm for Decision LBTC with uniform sensor radii, and shows that it always produces an optimal solution; Sect. 4 actually solves the LBTC problem by employing the binary search method, and then improve the runtime to \(O(mn(\log m+\log n))\); Sect. 5 concludes the paper.

2 \(\mathcal{NP}\)-Completeness of Decision 1D-LBTC

In this section, we shall show the Decision LBTC problem is \(\mathcal{NP}\)-complete when the sensors are with non-uniform integral radii by giving a reduction from the 3-partition problem. In the 3-partition problem that is known strongly \(\mathcal{NP}\)-complete, we are given a set of integers \(\mathcal{U}=\{a_{1},\,\dots ,\,a_{3n}\}\) with \(\sum _{i=1}^{3n}a_{i}=Bn\) for an integer \(B>0\). The aim is to determine whether \(\mathcal{U}\) can be divided into n subsets, such that each subset is with an equal sum B.

Theorem 2

Decision 1D-LBTC is \(\mathcal{NP}\)-complete when the sensors are with non-uniform integral radii.

The key idea of the proof is to construct a reduction from 3-Partition to the decision LBTC problem. For a given instance of 3-Partition, the construction of the corresponding instance of decision LBTC is simply as below:

  1. 1.

    Construct a line barrier with length \((2n-1)B\);

  2. 2.

    Place 2nB targets on the line barrier composed by n sections,where in the

    ith section, \(i=0,\,\dots ,\,n-1\), the targets are with positions \(2iB+j+j\epsilon \) and

    \(2iB+j+1-(B-j)\epsilon \), for \(j=0,\,\dots ,\,B-1\);

  3. 3.

    Place 3n sensors on position \((0,\,0)\), where sensor i is with radii \(\frac{a_{i}}{2}\);

  4. 4.

    The maximum movement is \(D=(2n-1)B\).

Note that, the instance of decision 1D-LBTC constructed above contains 2nB POIs and 3n sensors. Anyhow, 3-Partition is known strongly \(\mathcal{NP}\)-complete, which means, 3-Partition remains \(\mathcal{NP}\)-complete even when B is polynomial to n. Therefore, the construction can be done in polynomial time for B being polynomial to n.

The main idea behind the construction is to construct a relationship between the number of covered targets and the diameters of the sensors that are actually the integers in \(\mathcal{U}\). More precisely, the property on the relationship is as in the following:

Proposition 3

Against a 1D-LBTC instance produced by the above construction, a sensor with diameter 2r can cover at most 4r targets.

Proof

When a sensor is with a diameter 2, apparently it can cover at most 4 targets. Suppose the proposition is true for sensors with diameter smaller than 2r. Then, let \(r_{1}+r_{2}=r\) be two positive integers smaller than r. By induction, we have that sensors with diameters \(2r_{1}\) and \(2r_{2}\) can cover upto \(4r_{1}\) and \(4r_{2}\) targets, respectively. In addition, the two sensors with radii \(r_{1}\) and \(r_{2}\) can cover as many POIs as a sensor with a radii \(r=r_{1}+r_{2}\) does. Therefore, the sensor with diameter 2r can cover no more than \(4r_{1}+4r_{2}=4r\) targets. This completes the proof.    \(\square \)

Lemma 4

An instance of 3-Partition is feasible if and only if the corresponding 1D-LBTC instance is feasible.

Proof

Suppose the instance of 3-Partition is feasible. Without loss of generality, we assume that \(\{U_{i}\vert i=0,\,\dots ,\,n-1\}\) is a solution to the 3-Partition instance which divides \(\mathcal{U}\) to a collection of n sets, among which \(U_{i}=\{a_{l_{i}+1},\,\dots ,\,a_{l_{i+1}}\}\) and \(l_{0}=0\). Since \(D=(2n-1)B\) equals the length of the barrier and the original position of each sensor is \((0,\,0)\), each sensor can be moved any point of the barrier. Then we need only to use the sensors in \(U_{i}\), which are with radius \(a_{i_{j}},\,\dots ,\,a_{i_{j+1}}\) and with a sum exactly B, to cover the segment from 2iB to \((2i+1)B\). That apparently results in a coverage for all the targets in the ith section.

Conversely, suppose the corresponding LBTC instance is feasible. Then since sensor j with radii \(\frac{a_{j}}{2}\) can at most cover \(2a_{j}\) continuous targets, and each section contains exactly 2B targets, so the diameter sum of the sensors for each section is at least B. Then because the diameter sum of all the sensors is Bn, and there are n sections, the diameter sum of the sensors for each section is exactly B. Therefore, the diameters for the sensors for the sections is a solution to the corresponding instance of 3-Partition.    \(\square \)

From the fact that 3-Partition is strongly \(\mathcal{NP}\)-complete, and following a similar idea of the above proof for Theorem 2, we immediately have the following hardness for LBTC:

Corollary 5

Decision 1D-LBTC is strongly \(\mathcal{NP}\)-complete.

3 A Greedy Algorithm for 2D-LBTC with Uniform Sensors

The basic idea of the algorithm is to cover the target from left to right, preferably using sensors that are likely less useful for later coverage. More precisely, let \([l_{i},\,g_{i}]\) be the possible coverage range of sensor i, where \(l_{i}\) and \(g_{i}\) are respectively the positions of the leftmost and the rightmost targets, with respect to the given distance D. That is, \(l_{i}\) and \(g_{i}\) are the leftmost and the rightmost targets sensor i can cover within movement D. Then the key idea of our algorithm is to cover the targets from left to right, using the sensor that can cover the leftmost uncovered target within movement D and is with minimum \(g_{i}\).

The algorithm is first to compute its possible coverage range \([l_{i},\,g_{i}]\) for each sensor i with respect to the movement constraint D. Apparently, \((x_{i},\,0)\) is the projective point of sensor i on the line, so we have \(l_{i}=x_{i}-\sqrt{D^{2}-y_{i}^{2}}-D\) and \(g_{i}\) = \(x_{i}+\sqrt{D^{2}-y_{i}^{2}}\) for each sensor i. Then, the algorithm starts from point \(s=(0,\,0)\), to cover the line from left to right. The algorithm prefers using the sensor with a small \(g_{i}\), since a sensor with a large \(g_{i}\) would has a better potential to cover the targets on the right part of the line.

Let s be the position the uncovered leftmost target on the line barrier. Then among the set of sensors \(\{i\vert l_{i}\le s\le g_{i}\}\), the algorithm repeats selecting the sensor with minimum \(g_{i}\) to cover the uncovered targets of the line barrier starting at s. Note that \(\{i\vert l_{i}\le s\le g_{i}\}\) is exactly the set of sensors that can monitor a set of uncovered targets starting at s by relocating at most D distance. The algorithm terminates either the set of targets are completely covered, or the instance is found infeasible (i.e. there exists no unused sensor i with \(l_{i}\le s\le g_{i}\) while the coverage is not yet done). The detailed algorithm is formally as in Algorithm 1.

figure a

Note that Algorithm 1 takes O(n) time to compute \(l_{i}\) and \(g_{i}\) for all the sensors in Steps 2–3, and takes \(O(n\log n)\) time to assign the sensors to cover the targets on the line barrier in Steps 4–15. Therefore, we have the time complexity of the algorithm:

Lemma 6

Algorithm 1 runs in time \(O\left( n\log n\right) \).

Before proving the correctness of Algorithm 1, we need the following lemma stating the existence of a special coverage for a feasible LBTC instance.

Proposition 7

Let \((x_{j},\,y_{j})\) be the position of sensor j in the plane. Assume \(p_{1}(s,\,0)\), \(p_{2}(x'_{j},\,0)\) and \(p_{3}(x''_{j},\,0)\) are three points on a line segment. If \(s\le x''_{j}\le x_{j}'\), then \(d(j,\,p_{3})\le \max \{d(j,\,p_{1}),\,d(j,\,p_{2})\}\) holds. That is, the distance between the sensor and the middle point is not larger than the larger distance between the sensor and the other two points.

Lemma 8

If an instance of LBTC is feasible, then there must exist a coverage in which the sensors are s-ordered.

Proof

The key idea of the proof is that, any coverage of LBTC that is not s-ordered, can be converted to an s-ordered coverage by re-scheduling the sensors of covering the POIs.

Suppose there exist two sensors i and j, such that \(g_{i}>g_{j}\) but \(x_{i}'<x_{j}'\). Then we need only to swap the final positions of i and j, i.e. to simply set the new final positions \(x_{i}''\) and \(x_{j}''\) of sensor i and j as below: If \(x_{i}'-r\ge s\), then set \(x_{i}'':=x_{j}'\) and later \(x_{j}'':=x_{i}'\); Otherwise set \(x_{i}'':=x_{j}'\) and \(x_{j}'':=s+r\).

Apparently, the POIs exclusively covered by i are now covered by sensor j, and vice versa. So after the swap the sensors will remains a coverage for the POIs on the line. It remains to show the swap will not increase the maximum movement. Recall that the leftmost and the rightmost points sensor j can cover are respectively \(l_{j}\) and \(g_{j}\). Because sensor j can move to \(x_{j}'\) under the movement bound D, we have

$$\begin{aligned} l_{j}\le x'_{j}-r\le x'_{j}+r\le g_{j}\le g_{i}. \end{aligned}$$
(1)

On the other hand, in either case of the swap, we have \(x_{i}''=x_{j}'\ge x_{i}'\). So combining Inequality (1), we have \(l_{i}\le x_{i}''-r\le x''_{i}+r\le g_{i}.\) That means

$$ l_{i}+r\le x''_{i}\le g_{i}-r. $$

Then following Proposition 7, the distance between sensor i and its new position \(x_{i}''\) is bounded by \(D=\max \{d(i,\,(l_{i}+r,\,0)),\,d(i,\,(g_{i}-r,\,0))\}\). The case for the new position of sensor j is similar except that the distance between sensor j and its new position \(x_{i}''\) is bounded by \(D=\max \{d(j,\,(\max \{s,\,l_{j}+r\},\,0)),\,d(i,\,(g_{i}-r,\,0))\}\). This completes the proof.    \(\square \)

Based on Lemma 8, given a feasible instance of LBTC, we can assume there exists an s-ordered coverage, say \(\varGamma '=\{s_{1},\,\dots ,\,s_{k}\}\) which is the set of sensors used to compose the coverage with \(j_{i}\) being the rightmost target covered by \(s_{i}\). Then we have the following lemma, which leads to the correctness of the algorithm:

Lemma 9

When running against a feasible LBTC instance, Algorithm 1 covers the targets \(\{1,\,\dots ,\,j_{i}\}\) without using any sensor in \(\{s_{i+1},\,\dots ,\,s_{k}\}\).

Proof

We shall prove this claim by induction. When \(i=1\), the lemma is obviously true, as we need only \(s_{1}\) to cover the targets \(\{1,\dots ,\,j_{1}\}\). Suppose the lemma holds for \(i=h\), then it remains only to show the case for \(i=h+1\). By induction, Algorithm 1 covers the targets \(\{1,\,\dots ,\,j_{h}\}\) without using any sensor in \(\{s_{h+1},\,\dots ,\,s_{k}\}\). Then Algorithm 1 can simply cover targets \(\{j_{h}+1,\,\dots ,\,j_{h+1}\}\) by using sensor \(s_{h+1}\). Combining with the induction, we covers \(\{1,\,\dots ,\,j_{h+1}\}\) without using any sensor in \(\{s_{h+2},\,\dots ,\,s_{k}\}\). This completes the proof.    \(\square \)

We can now prove the following theorem to get the correctness of Algorithm 1:

Theorem 10

Algorithm 1 returns “feasible” iff the targets can be completely covered by the sensors within relocation distance D.

Proof

Suppose Algorithm 1 returns “feasible”, then obviously the produced solution \(\{x'_{i}\vert i\in \varGamma \}\) is truly a coverage, because in the solution the movement of each sensor is bounded by D and all the targets are covered by at least one sensor.

Conversely, suppose there is a coverage for the instance. Then by Lemma 8, there must exist an s-ordered coverage, say \(\varGamma '=\{s_{1},\,\dots ,\,s_{k}\}\) which is the set of sensors used to compose the coverage. Following Lemma 9, Algorithm 1 covers targets \(\{1,\,\dots ,\,j_{i}\}\) without using any sensor in \(\{s_{i+1},\,\dots ,\,s_{k}\}\) for every \(i\in [1,\,k]\). So the algorithm can always find sensors for further coverage, and in the worst case use \(s_{i+1}\) to cover the targets \(\{j_{i}+1,\,\dots ,\,j_{i+1}\}\). Therefore, the algorithm will eventually find a feasible coverage. This completes the proof.    \(\square \)

4 The Complete Algorithms

In this section, we will show how to employ Algorithm 1 to really compute \(D^{*}\) the minimum movement bound for LBTC. Firstly, when only considering integral \(D^{*}\), we can find it simply by employing the binary search method against a large range that contains \(D^{*}\); Secondly, for real number \(D^{*}\), we construct a set of size O(mn) which arguably contains \(D^{*}\), and then eventually finds \(D^{*}\) in the set again by the binary search method.

4.1 A Simple Binary Search Based Algorithm

The algorithm is simply applying the binary search method to find \(D^{*}\) within the range of \([1,\,d_{max}]\), where \(d_{max}\) is the maximum distance between the targets and the sensors. The main observation is as the following proposition whose correctness is easy to prove:

Proposition 11

If LBTC is feasible, then we have \(D^{*}\le d_{max}\).

The detailed algorithm is as in Algorithm 2.

figure b

For the correctness and time complexity of Algorithm 2, we immediately have the following lemma:

Lemma 12

Using binary search and employing Algorithm 1 for \(O(\log D_{max})\) times, Algorithm 2 will compute the optimum movement \(D^{*}\) within time complexity \(O(n\log n\log D_{max})\).

figure c

4.2 An Improved Algorithm via Discretized Binary Search

In this subsection, we shall show the time complexity of our algorithm can be further improved via a more sophisticated implementation over the binary search. The key observation is that, we need only to apply a binary search over a set of discrete values which arguably contain the optimum min-max movement \(D^{*}\). Let \(\{c_{1},\,\dots ,\,c_{t}\}\) be the set of possible combinations. Let \(d_{ij}\) be the minimum movement using sensor i to cover combination \(c_{j}\), where \(c_j\) is a set of POIs which can be exactly covered by a sensor. Then we have the following lemma:

Lemma 13

Let \(d_{opt}\) be an optimal solution to the uniform 2D-LBTC problem. Then \(d_{opt}\in \varPsi =\{d_{ij}\vert i\in \varGamma ,\,c_{j}\in \{c_{1},\,\dots ,\,c_{t}\}\}\).

Proof

Suppose the lemma is not true. Then let \(d_{max}=\max _{d}\{d\mid d\in \varPsi ,\,d<d_{opt}\}\). First we show that under maximum distance \(d_{max}\) and \(d_{opt}\), every sensor i covers an identical collection of combinations. That is because every POI, which sensor i can cover under movement bound \(d_{opt}\), can also be covered by sensor i under movement bound \(d_{max}\) (as \(d_{ij}\le d_{max}\) iff \(d_{ij}<d_{opt}\)), and conversely every POI, which cannot be covered by sensor i under \(d_{max}\), can not be covered by the same sensor within the movement bound \(d_{opt}\) (\(d_{ij}>d_{max}\) iff \(d_{ij}>d_{opt}\)). Therefore, a feasible coverage solution under maximum movement \(d_{opt}\) would also remain feasible under \(d_{max}\). This together with \(d_{max}<d_{opt}\) contradicts with the fact that \(d_{opt}\) is an optimal solution to the problem.    \(\square \)

Our algorithm will first compute the collection of distances between the combinations and the sensors, say \(\varPsi =\{d_{ij}\vert i\in \varGamma ,\,c_{j}\in \{c_{1},\,\dots ,\,c_{t}\}\}\), and then sort the distance in \(\varPsi \) in non-decreasing order. Then by applying the binary search method to \(\varPsi \) and using Algorithm 1 as a subroutine, we find a minimum \(d_{ij}\) under which there exists a relocation of the sensors such that all the targets can be covered. The detailed algorithm is as in Algorithm 3.

Lemma 14

The time complexity of Algorithm 3 is \(O(mn(\log m+\log n))\).

Proof

Apparently, \(\vert \varPhi \vert =O(m)\), so we have \(\vert \varPsi \vert =O(mn)\). Then sorting the elements in \(\varPsi \) takes \(O(\vert \varPsi \vert \log \vert \varPsi \vert )=O(mn\log mn)=O(mn(\log m+\log n))\) time. Besides, the while-loop from Step 12 to Step 20 will be repeated for at most \(O(\log m+\log n)\) times, each of which takes \(O(n\log n)\) time to run Algorithm 1. Therefore, the total time complexity of the algorithm is \(O(mn(\log m+\log n))\).

   \(\square \)

Theorem 15

Algorithm 3 produces an optimum solution to the LBTC problem.

5 Conclusion

In this paper, we first proved that 1D-LBTC is \(\mathcal{NP}\)-hard when the radius of the sensors are not identical, in contrast with the known result that 1D-LBC problem can be efficiently solved in a polynomial time. Then, we designed an algorithm for decision 2D-LBTC with uniform radius, and consequently proposed an algorithm for really solving 2D-LBTC based on the binary search method. Moreover, we improved the binary search method to a runtime \(O(mn(\log m+\log n))\) by observing that the optimum movement bound is within the set of distances between combinations of POIs and the sensors. We are currently investigating how to further improve the runtime of the algorithm.